[{
    Name: "Generic Color Light",
    Author: "Generoso Martello, modified by Tara Saint",
    Version: "2015-03-09",

    IconImage: 'pages/control/widgets/homegenie/generic/images/icons/colorbulbs.png',
    StatusText: '',
    HueLightNumber: '',
    ColorWheel: null,
    WidgetImage: null,
    ControlImage: null,

    RenderView: function (cuid, module) {
        if (cuid == null) return;
        var container = $(cuid);
        var widget = container.find('[data-ui-field=widget]');
        var controlpopup = widget.data('ControlPopUp');
        var toggle = widget.find('[data-ui-field=toggle]')
        
        //
        var deviceaddress = module.Address; //HG.WebApp.Utility.GetModulePropertyByName(module, "Philips.HueLight");
        //
        // Initialization -- If the controlpopup exists initialization has
        // already been done.
        //
        if (!controlpopup) {
            container.find('[data-ui-field=controlpopup]').trigger('create');
            controlpopup = container.find('[data-ui-field=controlpopup]').popup();
            widget.data('ControlPopUp', controlpopup);
            //
            var iconp1 = this.WidgetImage = Raphael(widget.find('[data-ui-field=colorsphereiconthingy]').get(0));
            var iconp2 = this.ControlImage = Raphael(controlpopup.find('[data-ui-field=color]').get(0));
            this.ColorWheel = Raphael.colorwheel(controlpopup.find('[data-ui-field=colors]'), 200, 80);
            //
            // Controlpopup event handlers:
            //
            // controlpopup on and off button actions
            controlpopup.find('[data-ui-field=on]').on('click', function () {
                HG.Control.Modules.ServiceCall("Control.On", module.Domain, module.Address, null, function (data) { });
            });
            controlpopup.find('[data-ui-field=off]').on('click', function () {
                HG.Control.Modules.ServiceCall("Control.Off", module.Domain, module.Address, null, function (data) { });
            });
            // colorwheel, oooooooh!
            this.ColorWheel.ondrag(null, function (rgbcolor) {
                var color = Raphael.color(rgbcolor);
                //
                iconp1.clear(); iconp1.ball(22, 22, 22, color);
                iconp2.clear(); iconp2.ball(22, 22, 22, color);
                //
                var hue = color.h;
                var sat = color.s;
                var bri = color.v;
                var hsbcolor = hue + "," + sat + "," + bri;
                //
                HG.Control.Modules.ServiceCall("Control.ColorHsb", module.Domain, module.Address, hsbcolor, function (data) { });
            });
            //
            // Widget event handlers:
            //
            // switch action
            toggle.on('change', function () {
              var cmd = 'Control.' + toggle.val();
              HG.Control.Modules.ServiceCall(cmd, module.Domain, module.Address, null, function (data) { });
              //UpdateIcon((toggle.val() == 'On') && true);
            });
            // when colorsphereiconthingy is clicked control popup is shown
            widget.find('[data-ui-field=colorsphereiconthingy]').on('click', function () {
                if ($(cuid).find('[data-ui-field=widget]').data('ControlPopUp')) {
                    $(cuid).find('[data-ui-field=widget]').data('ControlPopUp').popup('open');
                }
            });
            // When name is clicked, module edit popup is shown
            widget.find('[data-ui-field=name]').on('click', function () {
              HG.WebApp.Control.EditModule(module);
            });
        }
        //
        // get module level and watts props to build StatusText
        //
        var watts = HG.WebApp.Utility.GetModulePropertyByName(module, "Meter.Watts");
        watts = watts || HG.WebApp.Utility.GetModulePropertyByName(module, "Sensor.Power"); // Some devices don't meter but instead measure
        watts = watts && Math.round(watts.Value.replace(',', '.'));
        var level = HG.WebApp.Utility.GetModulePropertyByName(module, "Status.Level");
        level = (level && Math.round(level.Value.replace(',', '.') * 100)) || (watts && 100); // if level is not available, but watts > 0, it's on.
        this.StatusText = ((level && (level + '%')) || (watts && 'ON') || 'OFF') + ((watts && ('  (' + watts + 'W)')) || '');
        //
        var hsbcolor = HG.WebApp.Utility.GetModulePropertyByName(module, "Status.ColorHsb");
        if (hsbcolor != null && this.ColorWheel != null) {
            hsbcolor = 'hsb(' + hsbcolor.Value + ')';
            var color = Raphael.color(hsbcolor);
            if (level == 'OFF') color.v = 0.05;
            this.ColorWheel.color(hsbcolor);
            this.WidgetImage.clear(); this.WidgetImage.ball(16, 16, 16, color);
            this.ControlImage.clear(); this.ControlImage.ball(22, 22, 22, color);
        }
        //
        // render widget
        //
        widget.find('[data-ui-field=name]').html(module.Name);
        widget.find('[data-ui-field=status]').html(this.StatusText);
        toggle.val((level && 'On') || 'Off');
        toggle.slider('refresh');
        //
        // render control popup
        //
        controlpopup.find('[data-ui-field=group]').html(container.attr('data-context-group'));
        controlpopup.find('[data-ui-field=name]').html(module.Name);
        controlpopup.find('[data-ui-field=status]').html(level + '<br />' + watts);
    }
}]